/*
 * Copyright © 2019 iconectiv
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.openecomp.core.externaltesting.errors;

import lombok.Data;
import lombok.EqualsAndHashCode;
import org.apache.commons.lang3.builder.ToStringBuilder;

@Data
@EqualsAndHashCode(callSuper=false)
public class ExternalTestingException extends RuntimeException {

  private static final long serialVersionUID = -4357810130868566088L;

  private final String title;
  private final int code;
  private final String detail;

  public ExternalTestingException(String title, int code, String detail) {
    super(title);
    this.title = title;
    this.code = code;
    this.detail = detail;
  }

  public ExternalTestingException(String title, int code, String detail, Throwable parent) {
    super(title, parent);
    this.title = title;
    this.code = code;
    this.detail = detail;
  }

  @Override
  public String toString() {
    return ToStringBuilder.reflectionToString(this);
  }
}
